;;; translate-font-family-name.el
;;;
;;; Version: 2022/02/27
;;;
;;; Install
;;;  copy translate-font-family-name.el to /usr/share/emacs/site-lisp/.
;;;
;;; Setting
;;;  add to .emacs
;;;  ----
;;;  (require 'translate-font-family-name)
;;;  ----
;;;  実行方法
;;;    M-x translate-font-family-name
;;;

;;; Code:
(defcustom translate-font-family-name-trfamily-path
  "/usr/local/bin/trfamily.exe"
  "trfamily executable path"
  :type 'file
  :group 'translate-font-family-name)


(defun translate-font-family-name ()
  "英語のフォントファミリー名の一覧を取得する"
  (interactive)

  (let ((bufname "*TranslateFamily*")
        (trfamilypath )
        )
    (if (not (executable-find translate-font-family-name-trfamily-path))
        (message (format "Error: executable(%s) is not found." translate-font-family-name-trfamily-path))
      (switch-to-buffer bufname)
      (with-current-buffer (get-buffer-create bufname)
        (setq tab-width 32)
        (erase-buffer)
        (let ((utf8list '()))
          (dolist (f (delete-dups (font-family-list)))
            (add-to-list 'utf8list (decode-coding-string f 'utf-8)))
          (apply 'call-process translate-font-family-name-trfamily-path
                 nil t nil
                 (sort utf8list 'string<))
          )))))

(provide 'translate-font-family-name)
